package Chapter31;

public class File_31_4_7 {

  static final String IS_NUMERIC = "[+-]?\\d+(\\.\\d+)?";
  static final double ACCURACY = 0.0000000000001;

  public static void main(String[] args) throws java.io.IOException {
    java.io.BufferedReader cin = new java.io.
            BufferedReader(new java.io.InputStreamReader(System.in));
    double y, guess;
    String in;

    System.out.print("Enter a non-negative number: ");
    in = cin.readLine();
    while (in.matches(IS_NUMERIC) != true || Double.parseDouble(in) < 0) {
      System.out.println("Invalid value. Enter a non-negative number: ");
      in = cin.readLine();
    }
    y = Double.parseDouble(in);

    guess = 1 + Math.random() * y);	//Make a random first guess
                                    //between 1 and given value

    while (Math.abs(guess * guess - y) > ACCURACY) { //is it "close enough"?
      guess = (guess + y / guess) / 2;		  //No, create a new "guess"!
    }
    System.out.println(guess);
  }

}
