package Chapter37;

public class File_37_4_11 {

  static final int CARS = 10;
  static final int LAPS = 20;

  public static void main(String[] args) throws java.io.IOException {
    java.io.BufferedReader cin = new java.io.
            BufferedReader(new java.io.InputStreamReader(System.in));
    int i, j, m, n;
    double element;

    //Read names and elapsed times all together
    int[] names = new int[CARS];
    double[][] elapsed_times = new double[CARS][LAPS];
    for (i = 0; i <= CARS - 1; i++) {
      System.out.print("Enter name for driver No. " + (i + 1) + ": ");
      names[i] = Integer.parseInt(cin.readLine());
      for (j = 0; j <= LAPS - 1; j++) {
        System.out.print("Enter elapsed time for lap No. " + (j + 1) + ": ");
        elapsed_times[i][j] = Double.parseDouble(cin.readLine());
      }
    }

    //sort array elapsed_times
    for (i = 0; i <= CARS - 1; i++) {
      for (m = 1; m <= LAPS - 1; m++) {
        element = elapsed_times[i][m];
        n = m;
        while(n > 0 && elapsed_times[i][n - 1] < element) {
            elapsed_times[i][n] = elapsed_times[i][n - 1];
            n--;
        }
        elapsed_times[i][n] = element;
      }
    }

    //Display 3 worst elapsed times
    for (i = 0; i <= CARS - 1; i++) {
      System.out.println("Worst elapsed times of " + names[i]);
      System.out.println("-----------------------------------");
      for (j = 0; j <= 2; j++) {
        System.out.println(elapsed_times[i][j]);
      }
    }
  }

}
