package Chapter37;

public class File_37_5_10 {

  static final int EVENTS = 20;
  static final int COUNTRIES = 10;

  public static void main(String[] args) throws java.io.IOException {
    java.io.BufferedReader cin = new java.io.
            BufferedReader(new java.io.InputStreamReader(System.in));
    int j, i, needle, top, bottom, middle, row_index;
    boolean found;

    String[] country_names = new String[COUNTRIES];
    String[][] event_descriptions = new String[EVENTS][COUNTRIES];
    int[][] event_years = new int[EVENTS][COUNTRIES];
    for (j = 0; j <= COUNTRIES - 1; j++) {
      System.out.print("Enter Country No. " + (j + 1) + ": ");
      country_names[j] = cin.readLine();
      for (i = 0; i <= EVENTS - 1; i++) {
        System.out.print("Enter description for event No. " + (i + 1) + ": ");
        event_descriptions[i][j] = cin.readLine();
        System.out.print("Enter year for event No. " + (i + 1) + ": ");
        event_years[i][j] = Integer.parseInt(cin.readLine());      
      }
    }

    System.out.print("Enter a year to search: ");
    needle = Integer.parseInt(cin.readLine());
    row_index = -1;

    for (j = 0; j <= COUNTRIES - 1; j++) {
      top = 0;
      bottom = EVENTS - 1;
      found = false;
      while (top <= bottom && found == false) {
        middle = (int)((top + bottom) / 2);

        if (event_years[middle][j] > needle) {
          bottom = middle - 1;
        }
        else if (event_years[middle][j] < needle) {
          top = middle + 1;
        }
        else {
          found = true;
          row_index = middle;
        }
      }

      if (found == false) {
        System.out.println("No event found for country " + country_names[j]);
      }
      else {
        System.out.println("Country: " + country_names[j]);
        System.out.println("Year: " + event_years[row_index][j]);
        System.out.println("Event: " + event_descriptions[row_index][j] + "\n");
      }
    }
  }

}
