package Chapter23;

public class File_23_4_6 {

static final String IS_NUMERIC = "[-+]?\\d+(\\.\\d+)?";

  public static void main(String[] args) throws java.io.IOException {
    java.io.BufferedReader cin = new java.io.
            BufferedReader(new java.io.InputStreamReader(System.in));
    int kwh;
    double t;
    String kwh_str;

    System.out.print("Enter number of Kilowatt-hours consumed: ");
    kwh_str = cin.readLine();

    if (kwh_str.matches(IS_NUMERIC) != true) {
      System.out.println("Entered value contains non-numeric characters");
    }
    else {
      kwh = Integer.parseInt(kwh_str);
      if (kwh < 0) {
        System.out.println("Entered value is negative");
      }
      else {
        if (kwh <= 500) {
          t = kwh * 0.10;
        }
        else if (kwh <= 2000) {
          t = 0.25 * kwh - 75;
        }
        else if (kwh <= 4000) {
          t = 0.4 * kwh - 375;
        }
        else {
          t = 0.6 * kwh - 1175;
        }

        t = 1.10 * t;  	//This is equivalent to 
                          //t = t + t * 10 / 100
                          //but more efficient 

        System.out.println("Total amount to pay (taxes included): " + t);
      }
    }
  }

}
