package Chapter37;

public class File_37_4_7 {

  static final int TEAMS = 32;
  static final int PLAYERS = 24;

  public static void main(String[] args) throws java.io.IOException {
    java.io.BufferedReader cin = new java.io.
            BufferedReader(new java.io.InputStreamReader(System.in));
    int i, j, m, n, temp;
    boolean swaps;
    String temp_str;

    //Read team names, player names and goals all together
    String[] t = new String[TEAMS];
    String[][] p = new String[TEAMS][PLAYERS];
    int[][] g = new int[TEAMS][PLAYERS];
    for (i = 0; i <= TEAMS - 1; i++) {
      System.out.println("Enter name for team No. " + (i + 1) + ": ");
      t[i] = cin.readLine();
      for (j = 0; j <= PLAYERS - 1; j++) {
        System.out.println("Enter name of player No. " + (j + 1) + ": ");
        p[i][j] = cin.readLine();
        System.out.println("Enter goals of player No. " + (j + 1) + ": ");
        g[i][j] = Integer.parseInt(cin.readLine());
      }
    }

    //sort array g
    for (i = 0; i <= TEAMS - 1; i++) {
      m = 1;
      swaps = true;
      while (m <= PLAYERS - 1 && swaps == true) {        
        swaps = false;
        for (n = PLAYERS - 1; n >= m; n--) {
          if (g[i][n] > g[i][n - 1]) {
            temp = g[i][n];
            g[i][n] = g[i][n - 1];
            g[i][n - 1] = temp;

            temp_str = p[i][n];
            p[i][n] = p[i][n - 1];
            p[i][n - 1] = temp_str;

            swaps = true;
          }
        }
        m++;
      }
    }

    //Display 5 best scorers of each team
    for (i = 0; i <= TEAMS - 1; i++) {
      System.out.println("Best scorers of " + t[i]);
      System.out.println("-----------------------------------");
      for (j = 0; j <= 4; j++) {
        System.out.println(p[i][j] + " scored " + g[i][j] + " goals");
      }
    }  
  }

}
