package Chapter37;

public class File_37_5_9 {

  static final int EVENTS = 20;
  static final int COUNTRIES = 10;

  public static void main(String[] args) throws java.io.IOException {
    java.io.BufferedReader cin = new java.io.
            BufferedReader(new java.io.InputStreamReader(System.in));
    int j, i, left, right, middle, index_position;
    boolean found;
    String needle;

    String[] country_names = new String[COUNTRIES];
    String[][] event_descriptions = new String[EVENTS][COUNTRIES];
    for (j = 0; j <= COUNTRIES - 1; j++) {
      System.out.print("Enter Country No. " + (j + 1) + ": ");
      country_names[j] = cin.readLine();
      for (i = 0; i <= EVENTS - 1; i++) {
        System.out.print("Enter description for event No. " + (i + 1) + ": ");
        event_descriptions[i][j] = cin.readLine();   
      }
    }

    System.out.print("Enter a country to search: ");
    needle = cin.readLine().toUpperCase();

    index_position = -1;
    left = 0;
    right = EVENTS - 1;
    found = false;
    while (left <= right && found == false) {
      middle = (int)((left + right) / 2);

      if (country_names[middle].toUpperCase().compareTo(needle) > 0) {
        right = middle - 1;
      }
      else if (country_names[middle].toUpperCase().compareTo(needle) < 0) {
        left = middle + 1;
      }
      else {
        found = true;
        index_position = middle;
      }
    }

    if (found == false) {
      System.out.println("No country found!");
    }
    else {
      for (i = 0; i <= EVENTS - 1; i++) {
        System.out.println(event_descriptions[i][index_position]);
      }
    }
  }

}
