package Chapter43;

public class File_43_2_1 {

  static final String IS_NUMERIC = "[+-]?\\d+(\\.\\d+)?";
  static final int PEOPLE = 50;

  static int get_age() throws java.io.IOException {
    java.io.BufferedReader cin = new java.io.
            BufferedReader(new java.io.InputStreamReader(System.in));
    String x;

    System.out.println("Enter an age: ");
    x = cin.readLine();
    while (x.matches(IS_NUMERIC) != true || Integer.parseInt(x) <= 0) {
      System.out.println("Error: Invalid age!");
      System.out.println("Enter a positive number: ");
      x = cin.readLine();
    }
    return Integer.parseInt(x);
  }

  static int find_max(int[] a) {
    int i, max, max_i;

    max = a[0];
    max_i = 0;
    for (i = 1; i <= PEOPLE - 1; i++) {
      if (a[i] > max) {
        max = a[i];
        max_i = i;
      }
    }
    return max_i;
  }

  public static void main(String[] args) throws java.io.IOException {
    java.io.BufferedReader cin = new java.io.
            BufferedReader(new java.io.InputStreamReader(System.in));    
    int i, index_of_max;

    String[] first_names = new String[PEOPLE];
    String[] last_names = new String[PEOPLE];
    int[] ages = new int[PEOPLE];
    for (i = 0; i <= PEOPLE - 1; i++) {
      System.out.println("Enter first name of person No " + (i + 1) + ": ");
      first_names[i] = cin.readLine();
      System.out.println("Enter last name of person No " + (i + 1) + ": ");
      last_names[i] = cin.readLine();
      ages[i] = get_age();
    }

    index_of_max = find_max(ages);

    System.out.println("The oldest person is:");
    System.out.println(first_names[index_of_max]);
    System.out.println(last_names[index_of_max]);
    System.out.println("He or she is " + ages[index_of_max] + " years old!");
  }

}
